// process_text_stream.cpp
//
#ifdef _WIN32
	#pragma warning(disable:4996)
	#include <tchar.h>
	#include <windows.h>
	#include <conio.h>
	#include <direct.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	#include <stdlib.h>
	#include <sys/types.h>
	#include <sys/stat.h>
	#include <unistd.h>
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <stdio.h>
#include <string.h>
#include <fstream>
#include <iostream>
#include <iomanip>
using namespace std;

#include "Veta.h"

#define MAXLINE 255

void my_getch();
void GetNamesOfIOFiles(const char[], char[]);
//---------------------------------------------------------------------------
int _tmain(int argc, _TCHAR* argv[])
{
	ifstream in;
	VetaClass** veta;
	unsigned i, j, k, n, PocetViet;
	char c, * str, nameoffile[MAXLINE];

	cout << "\n  Tento program nacita vetu z textoveho suboru, vyhodi z nej "
		<< "prebytocne\nmedzery a na obrazovku vypise upravenu vetu a potom"
		<< " pod seba jednotlive slova\nspolu s ich dlzkami.\n\n";

	GetNamesOfIOFiles("VETY.TXT", nameoffile);
	in.open(nameoffile, ios::in);
	if (!in) {
		cout << "  Subor VETY.TXT sa nepodarilo otvorit.\n";
		my_getch();
		exit(1);
	}

	i = 0;
	veta = new VetaClass * [50];
	do {
		do {
			in.get(c);
		} while ((!isalnum(c)) && (!ispunct(c)) && (!in.eof()));

		if ((isalnum(c)) || (ispunct(c))) {
			veta[i] = new VetaClass;
			in.putback(c);
			in >> veta[i];
			i++;
		}
	} while (!in.eof());
	PocetViet = i;
	in.close();

	cout << "  Zadana veta:\n\n";
	cout << "  ";
	for (i = 0; i < PocetViet; i++)
		cout << veta[i];
	cout << "\n\n  Press any key!";
	my_getch();

	n = 0;
	cout << "\n\n  Slova vety           Dlzka slov\n";
	for (i = 0; i < PocetViet; i++) {
		for (j = 0; j < veta[i]->PocetSlov; j++) {
			str = veta[i]->DajSlovo(j);
			k = (unsigned)strlen(str);
			cout << "\n  " << str;
			cout.setf(ios::right);
			cout << setw(27 - k) << k;
			n++;
			if (n % 40 == 0) {
				n = 0;
				cout << "\n\n  Press any key!\n";
				my_getch();
			}
		}
	}
	cout << endl;

	for (i = 0; i < PocetViet; i++)
		delete veta[i];
	delete[] veta;

	my_getch();
	return 0;
}
//---------------------------------------------------------------------------
void my_getch()
{
#ifdef _WIN32
	_getch();
#else
	cout << endl;
#endif
}
//---------------------------------------------------------------------------
void GetNamesOfIOFiles(const char name_of_input_file[], char path_to_input_file[])
{
	char current_path[MAXLINE];
	current_path[0] = '\0';

#ifdef _WIN32
	TCHAR exePath[MAXLINE];

	HMODULE hModule = GetModuleHandle(NULL);
	if (hModule != NULL) {
		if (!GetModuleFileName(hModule, exePath, MAXLINE)) {
			cout << "Nepodarila sa zistit cesta k exe-suboru.\n";
			my_getch();
			exit(1);
		}
	}
	else {
		cout << "Module handle is NULL.\n" << endl;
		my_getch();
		exit(1);
	}
#ifdef __BORLANDC__
	int iii;
	bool flag = false;
	for (iii = strlen(exePath); iii >= 0; iii--) {
		if (!flag && exePath[iii] == '\\') {
			current_path[iii + 1] = '\0';
			flag = true;
		}
		if (flag)
			current_path[iii] = (char)exePath[iii];
	}
#else
	int iii;
	bool flag = false;
	for (iii = (int)wcslen(exePath); iii >= 0; iii--) {
		if (!flag && exePath[iii] == '\\') {
			current_path[iii + 1] = '\0';
			flag = true;
		}
		if (flag)
			current_path[iii] = (char)exePath[iii];
	}
#endif
#elif (defined __linux__) || (defined __APPLE__)
	unsigned iii;
	char line[MAXLINE];
	FILE* fp;
	if ((fp = popen("/bin/pwd", "r")) == NULL) {
		perror("popen error");
		exit(1);
	}
	if (fgets(line, MAXLINE, fp) == NULL) {
		perror("fgets error");
		exit(1);
	}
	pclose(fp);

	iii = 0;
	while (line[iii] != '\r' && line[iii] != '\n') {
		current_path[iii] = line[iii];
		iii++;
	}
	current_path[iii] = '\0';
#elif (defined _AIX)
	unsigned iii;
	char line[MAXLINE];
	FILE* fp;
	if ((fp = popen("user/bin/pwd", "r")) == NULL) {
		perror("popen error");
		exit(1);
	}
	if (fgets(line, MAXLINE, fp) == NULL) {
		perror("fgets error");
		exit(1);
	}
	pclose(fp);

	iii = 0;
	while (line[iii] != '\r' && line[iii] != '\n') {
		current_path[iii] = line[iii];
		iii++;
	}
	current_path[iii] = '\0';
#endif

	path_to_input_file[0] = '\0';
	strcat(path_to_input_file, current_path);
#if (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	strcat(path_to_input_file, "/inputs/");
#elif (defined _WIN32)
	strcat(path_to_input_file, "inputs\\");
#endif
	strcat(path_to_input_file, name_of_input_file);
}
//---------------------------------------------------------------------------
